package com.lanren.huhu.partner.constants;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Map;

/**
 * @author chen
 * @title: Constants
 * @projectName partner
 * @description: 常量
 * @package com.lanren.huhu.partner.constants
 * @date 2019-06-29 17:04
 */
public class Constants {
    public static final String AGENT_REWARD_QUEUE_KEY = "agent_reward_redis_city_key";
    /**
     * 代理商奖励类型
     *
     * 800，810，780 - 表3
     * 790-表1
     */
    public static final int AGENT_REWARD_TYPE_YEAR_VIP = 710;
    public static final String AGENT_REWARD_TYPE_YEAR_VIP_REMARK = "高级年vip";
    public static final int AGENT_REWARD_TYPE_HALF_YEAR_VIP = 720;
    public static final String AGENT_REWARD_TYPE_HALF_YEAR_VIP_REMARK = "高级半年vip";
    public static final int AGENT_REWARD_TYPE_SVIP = 730;
    public static final String AGENT_REWARD_TYPE_SVIP_REMARK = "超级年vip";
    public static final int AGENT_REWARD_TYPE_REDPACK = 740;
    public static final String AGENT_REWARD_TYPE_REDPACK_REMARK = "推荐奖励-普通用户购买红包";
    public static final int AGENT_REWARD_TYPE_SELF_ORDER = 750;
    public static final String AGENT_REWARD_TYPE_SELF_ORDER_REMARK = "推荐奖励-自购省";
    public static final int AGENT_REWARD_TYPE_SHARE_ORDER = 760;
    public static final String AGENT_REWARD_TYPE_SHARE_ORDER_REMARK = "推荐奖励-分享赚";
    public static final int AGENT_REWARD_TYPE_VIP_PACKAGE = 780;
    public static final String AGENT_REWARD_TYPE_VIP_PACKAGE_REMARK = "购买vip礼包(不送会员)";
    public static final int AGENT_REWARD_TYPE_PACKAGE_WITH_VIP = 790;
    public static final String AGENT_REWARD_TYPE_PACKAGE_WITH_VIP_REMARK = "购买vip礼包(送会员)";
    public static final int AGENT_REWARD_TYPE_VIP_CARD = 800;
    public static final String AGENT_REWARD_TYPE_VIP_CARD_REMARK = "购买vip卡";
    public static final int AGENT_REWARD_TYPE_SVIP_CARD = 810;
    public static final String AGENT_REWARD_TYPE_SVIP_CARD_REMARK = "购买svip卡";
    public static final int JD_OFFSET = 1000; //用于查找京东的平推奖励比例
    public static final int MT_OFFSET = 2000; //用于查找美团的平推奖励比例
    public static final int TN_OFFSET = 3000; //用于查找途牛的平推奖励比例
    public static final int MTJD_OFFSET = 4000; //用于查找美团酒店的平推奖励比例
    public static final int ELM_OFFSET = 5000; //用于查找饿了么的平推奖励比例
    public static final int KFC_OFFSET = 6000; //用于查找饿了么的平推奖励比例
    public static final int HHYX_OFFSET = 7000; //用于查找自营呼呼优选的平推奖励比例
    public static Map<Integer, Map<Integer, BigDecimal>> AGENT_RATE_MAP = new HashMap<Integer, Map<Integer, BigDecimal>>();
    public static Map<Integer, String> AGENT_REWARD_REMARK = new HashMap<Integer, String>();
    public static final int AGENT_LEVEL_1 = 1;
    public static final int AGENT_LEVEL_2 = 2;
    public static final int AGENT_LEVEL_3 = 3;
    public static final int AGENT_LEVEL_4 = 4;
    public static final String DISTRIBUTE_REDIS_LOCK_KEY = "huhu:partner:distribute:redis:key";
    public static final String PARENT_COLUMN_NAME_CENGJI = "parent_agent_id";
    public static final String PARENT_COLUMN_NAME_PINGTUI = "presenter_id";
    public static final String ORDER_TYPE_JD = "jd";
    public static final String ORDER_TYPE_MT = "mt";
    public static final String ORDER_TYPE_TN = "tuniu";
    public static final String ORDER_TYPE_MTJD = "mt_jd";
    public static final String ORDER_TYPE_ELM = "elm";
    public static final String ORDER_TYPE_KFC = "kfc";
    public static final String ORDER_TYPE_HHYX = "hhyx";
    /**
     * 回扣类型
     */
    public static final int AGENT_REVOKE_TYPE_ACTIVATION = 100;
    public static final String AGENT_REVOKE_TYPE_ACTIVATION_REMARK = "下单激活奖励扣回";
    public static final int AGENT_REVOKE_TYPE_SELF_ORDER = 300;
    public static final String AGENT_REVOKE_TYPE_SELF_ORDER_REMARK = "自购省奖励扣回";
    public static final int AGENT_REVOKE_TYPE_SHARE_ORDER = 400;
    public static final String AGENT_REVOKE_TYPE_SHARE_ORDER_REMARK = "分享赚奖励扣回";
    public static Map<Integer, String> AGENT_REVOKE_TYPE_MAP = new HashMap<Integer, String>();

    /**
     * 回扣状态
     */
    public static final int REVOKE_STATE_PENDING = 100;
    public static final int REVOKE_STATE_DONE = 120;
    public static final int REVOKE_STATE_DO_NOTHING = 190;
    public static final int REVOKE_STATE_FAILED = 99;
    /**
     * 显示结算状态
     */
    public static final int SETTLE_STATE_ON_THE_WAY = 100;
    public static final int SETTLE_STATE_PRE = 200;
    public static final int SETTLE_STATE_DONE = 300;
    public static final int SETTLE_STATE_FAILED = -300;

    /**
     * 最小奖励金额 小于此不写入
     */
    public static final BigDecimal MIN_REWARD = new BigDecimal("0.000001");

    /**
     * 代理商奖励push队列
     */
    public static final String AGENT_REWARD_PUSH_KEY = "agent:reward:queue";

    static {
        /**
         * 代理商平推奖励比例配置
         */
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_YEAR_VIP, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_HALF_YEAR_VIP, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_SVIP, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_VIP_PACKAGE, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_VIP_CARD, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_SVIP_CARD, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_PACKAGE_WITH_VIP, new HashMap<Integer, BigDecimal>());

        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_REDPACK, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_SELF_ORDER, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_SHARE_ORDER, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_SELF_ORDER + JD_OFFSET, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_SHARE_ORDER + JD_OFFSET, new HashMap<Integer, BigDecimal>());

        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_SELF_ORDER + MT_OFFSET, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_SELF_ORDER + TN_OFFSET, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_SELF_ORDER + MTJD_OFFSET, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_SELF_ORDER + ELM_OFFSET, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_SELF_ORDER + KFC_OFFSET, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_SELF_ORDER + HHYX_OFFSET, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_SHARE_ORDER + HHYX_OFFSET, new HashMap<Integer, BigDecimal>());
//      710，720，730 - 表2 - 购买VIP会员-无礼包
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_YEAR_VIP).put(0, new BigDecimal("0.04040404"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_YEAR_VIP).put(1, new BigDecimal("0.02020202"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_HALF_YEAR_VIP).put(0, new BigDecimal("0.04040404"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_HALF_YEAR_VIP).put(1, new BigDecimal("0.02020202"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SVIP).put(0, new BigDecimal("0.04040404"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SVIP).put(1, new BigDecimal("0.02020202"));
//      780 购买vip礼包(不送会员), 800 购买vip卡, 810 购买svip卡  -  表3 - 购买V卡、超V卡、单独礼包
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_VIP_PACKAGE).put(0, new BigDecimal("0.04"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_VIP_PACKAGE).put(1, new BigDecimal("0.02"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_VIP_CARD).put(0, new BigDecimal("0.04040404"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_VIP_CARD).put(1, new BigDecimal("0.02020202"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SVIP_CARD).put(0, new BigDecimal("0.05050506"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SVIP_CARD).put(1, new BigDecimal("0.02525253"));
//      790 - 表1 - 购买礼包+送VIP会员
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_PACKAGE_WITH_VIP).put(0, new BigDecimal("0.04"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_PACKAGE_WITH_VIP).put(1, new BigDecimal("0.02"));
        /**
         * 红包
         */
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_REDPACK).put(0, new BigDecimal("0.03"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_REDPACK).put(1, new BigDecimal("0.02"));
        /**
         * 自购省
         */
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SELF_ORDER).put(0, new BigDecimal("0.009"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SELF_ORDER).put(1, new BigDecimal("0.009"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SELF_ORDER + JD_OFFSET).put(0, new BigDecimal("0.0087"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SELF_ORDER + JD_OFFSET).put(1, new BigDecimal("0.0087"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SELF_ORDER + MT_OFFSET).put(0, new BigDecimal("0.01"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SELF_ORDER + MT_OFFSET).put(1, new BigDecimal("0.01"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SELF_ORDER + TN_OFFSET).put(0, new BigDecimal("0.01"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SELF_ORDER + TN_OFFSET).put(1, new BigDecimal("0.01"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SELF_ORDER + MTJD_OFFSET).put(0, new BigDecimal("0.01"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SELF_ORDER + MTJD_OFFSET).put(1, new BigDecimal("0.01"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SELF_ORDER + ELM_OFFSET).put(0, new BigDecimal("0.01"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SELF_ORDER + ELM_OFFSET).put(1, new BigDecimal("0.01"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SELF_ORDER + KFC_OFFSET).put(0, new BigDecimal("0.01"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SELF_ORDER + KFC_OFFSET).put(1, new BigDecimal("0.01"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SELF_ORDER + HHYX_OFFSET).put(0, new BigDecimal("0.07"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SELF_ORDER + HHYX_OFFSET).put(1, new BigDecimal("0.08"));
        /**
         * 分享赚
         */
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SHARE_ORDER).put(0, new BigDecimal("0.009"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SHARE_ORDER).put(1, new BigDecimal("0.009"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SHARE_ORDER + JD_OFFSET).put(0, new BigDecimal("0.0087"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SHARE_ORDER + JD_OFFSET).put(1, new BigDecimal("0.0087"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SHARE_ORDER + HHYX_OFFSET).put(0, new BigDecimal("0.07"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SHARE_ORDER + HHYX_OFFSET).put(1, new BigDecimal("0.08"));

        AGENT_REWARD_REMARK.put(AGENT_REWARD_TYPE_YEAR_VIP, AGENT_REWARD_TYPE_YEAR_VIP_REMARK);
        AGENT_REWARD_REMARK.put(AGENT_REWARD_TYPE_HALF_YEAR_VIP, AGENT_REWARD_TYPE_HALF_YEAR_VIP_REMARK);
        AGENT_REWARD_REMARK.put(AGENT_REWARD_TYPE_SVIP, AGENT_REWARD_TYPE_SVIP_REMARK);
        AGENT_REWARD_REMARK.put(AGENT_REWARD_TYPE_VIP_PACKAGE, AGENT_REWARD_TYPE_VIP_PACKAGE_REMARK);
        AGENT_REWARD_REMARK.put(AGENT_REWARD_TYPE_PACKAGE_WITH_VIP, AGENT_REWARD_TYPE_PACKAGE_WITH_VIP_REMARK);
        AGENT_REWARD_REMARK.put(AGENT_REWARD_TYPE_REDPACK, AGENT_REWARD_TYPE_REDPACK_REMARK);
        AGENT_REWARD_REMARK.put(AGENT_REWARD_TYPE_SELF_ORDER, AGENT_REWARD_TYPE_SELF_ORDER_REMARK);
        AGENT_REWARD_REMARK.put(AGENT_REWARD_TYPE_SHARE_ORDER, AGENT_REWARD_TYPE_SHARE_ORDER_REMARK);
        AGENT_REWARD_REMARK.put(AGENT_REWARD_TYPE_VIP_CARD, AGENT_REWARD_TYPE_VIP_CARD_REMARK);
        AGENT_REWARD_REMARK.put(AGENT_REWARD_TYPE_SVIP_CARD, AGENT_REWARD_TYPE_SVIP_CARD_REMARK);
        /**
         * 代理商奖励回扣类型
         */
        AGENT_REVOKE_TYPE_MAP.put(AGENT_REVOKE_TYPE_ACTIVATION, AGENT_REVOKE_TYPE_ACTIVATION_REMARK);
        AGENT_REVOKE_TYPE_MAP.put(AGENT_REVOKE_TYPE_SELF_ORDER, AGENT_REVOKE_TYPE_SELF_ORDER_REMARK);
        AGENT_REVOKE_TYPE_MAP.put(AGENT_REVOKE_TYPE_SHARE_ORDER, AGENT_REVOKE_TYPE_SHARE_ORDER_REMARK);
    }
}
