package com.lanren.huhu.partner.model;

import com.alibaba.fastjson.annotation.JSONField;
import com.lanren.huhu.partner.model.base.BaseModel;
import lombok.Data;

import java.util.Objects;

/**
 * @author chen
 * @title: ParentAgent
 * @projectName partner
 * @description: 上级代理商
 * @package com.lanren.huhu.partner.model
 * @date 2019-06-2711:20
 */
@Data
public class ParentAgent extends BaseModel {
    int userId;
    int agentId;
    int level;
    @JSONField(serialize=false)
    int agentState;

    public ParentAgent(int userId, int agentId, int level, int agentState) {
        this.userId = userId;
        this.agentId = agentId;
        this.level = level;
        this.agentState = agentState;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof ParentAgent)) {
            return false;
        }
        ParentAgent that = (ParentAgent) o;
        return agentId == that.agentId;
    }

    @Override
    public int hashCode() {
        return Objects.hash(agentId);
    }
}
